# Compatibility with legacy rpm.
%{!?_lib:%define _lib	lib}

%ifnarch ia64 
Conflicts: glibc < 2.1.90 
%endif 

%define db2_versions 2
%define db3_versions 3.1.17 3.2.9 3.3.11
%define db4_versions 4.0.14

# XXX avoid ppc64 toolchain for the nonce.
ExcludeArch: ppc64

# Use gcc296 for systems on which we're replacing shared libraries from RHL
# 7.x, the regular system gcc for everything else (though we shouldn't need
# this package on those architectures anyway).

%ifarch i386 alpha ia64
BuildPreReq: compat-gcc, compat-gcc-c++
%define compat_gcc_suffix	296
%define compat_cc		gcc%{compat_gcc_suffix}
%define compat_cxx		g++%{compat_gcc_suffix}
%else
%define compat_cc		gcc
%define compat_cxx		g++
%endif

%define _libdb_a		libdb-${soversion}.a
%define _libcxx_a		libdb_cxx-${soversion}.a

Summary: The Berkeley DB database library for Red Hat Linux 7.x compatibility.
Name: compat-db
Version: 4.0.14
Release: 5
# Tarball taken from glibc 2.1.3  
#Source0: http://www.sleepycat.com/update/2.7.7/db-2.7.7.tar.gz  
Source0: db2-glibc-2.1.3.tar.gz
Source1: http://www.sleepycat.com/update/3.1.17/db-3.1.17.tar.gz
Source2: http://www.sleepycat.com/update/3.2.9/db-3.2.9.tar.gz
Source3: http://www.sleepycat.com/update/3.3.11/db-3.3.11.tar.gz
Source4: http://www.sleepycat.com/update/4.0.14/db-4.0.14.tar.gz

# Patch to make it standalone
Patch0: db2-glibc-2.1.3.patch
Patch1: db2-2.4.14-db2.patch
Patch2: db2-2.4.14-s390.patch
Patch3: db2-2.4.14-nodebug.patch
Patch4: db2-2.4.14-fileid_64bit_fix.patch
Patch5: db-3.1.17-tcl.patch
Patch6: http://www.sleepycat.com/update/3.2.9/patch.3.2.9.1
Patch7: http://www.sleepycat.com/update/3.2.9/patch.3.2.9.2
Patch8: http://www.sleepycat.com/update/3.3.11/patch.3.3.11.1
Patch9: http://www.sleepycat.com/update/3.3.11/patch.3.3.11.2
Patch15: db4-4.0.14-configure.patch
Patch16: db4-4.0.14-recover.patch

Obsoletes: db2, db2-devel, db2-utils
Obsoletes: db3, db3-devel, db3-utils
Obsoletes: db31, db32, db3x
Obsoletes: db4 < 4.1, db4-devel < 4.1, db4-utils < 4.1
URL: http://www.sleepycat.com/
License: BSDish
Group: System Environment/Libraries
BuildPreReq: findutils, libtool, perl, sed, tcl, tcl-devel
BuildRoot: %{_tmppath}/%{name}-root

%description
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
This package contains various versions of Berkeley DB which were included in
previous releases of Red Hat Linux.

%prep
%setup -q -c -a 1 -a 2 -a 3 -a 4

pushd db2
%patch0 -p1  
%patch1 -p1 -b .db2  
%patch2 -p1 -b .fpic  
%patch3 -p1 -b .nodebug  
%patch4 -p1 -b .64fix  
popd

pushd db-3.1.17
%patch5 -p1 -b .tcl
popd

pushd db-3.2.9
%patch6 -p0 -b .1
%patch7 -p0 -b .2
popd

pushd db-3.3.11
%patch8 -p0 -b .1
%patch9 -p0 -b .2
popd

pushd db-4.0.14
%patch15 -p1 -b .configure
%patch16 -p1 -b .recover
popd

mkdir docs
for version in 2 %{db3_versions} ; do
	mkdir docs/db-${version}
	install -m644 db*${version}/{README,LICENSE} docs/db-${version}
done

%build
# Build with gcc/g++ 2.96 to maintain compatibility for apps which were built
# with db3's C++ libraries on a 2.96 system.
CC=%{compat_cc} ; export CC
CXX=%{compat_cxx} ; export CXX

# Set CFLAGS for use when building db2, where there's no configure script to
# pick it up from a %%configure macro.
CFLAGS="$RPM_OPT_FLAGS"; export CFLAGS

# Cause C++ libraries to be linked with libstdc++.
LIBXSO_LIBS=-lstdc++; export LIBXSO_LIBS

pushd db2
make
popd

for version in %{db3_versions} ; do
	pushd db-${version}/dist
# XXX --enable-posixmutexes is useful for threads but useless for interprocess locking.
# XXX --enable-diagnostic should be disabled for production (but is useful).
# XXX --enable-debug_{r,w}op should be disabled for production.
# XXX --enable-java
	libtoolize --force 
	%configure --prefix=%{_prefix} \
		--enable-compat185 \
		--enable-shared --disable-static \
		--enable-rpc --enable-tcl --with-tcl=%{_libdir} \
		--enable-cxx --enable-test \
		# --enable-diagnostic \
		# --enable-debug --enable-debug_rop --enable-debug_wop \
		# --enable-posixmutexes

	soversion=`echo ${version} | cut -f1,2 -d.`
	make libdb=%{_libdb_a} libcxx=%{_libcxx_a}
	popd
done

# db-4.x builds with the (current) system compiler
CC=gcc ; export CC
CXX=g++ ; export CXX

for version in %{db4_versions} ; do
	pushd db-${version}/dist
# XXX --enable-posixmutexes is useful for threads but useless for interprocess locking.
# XXX --enable-diagnostic should be disabled for production (but is useful).
# XXX --enable-debug_{r,w}op should be disabled for production.
# XXX --enable-java
	libtoolize --force 
	%configure --prefix=%{_prefix} \
		--enable-compat185 \
		--enable-shared --disable-static \
		--enable-rpc --enable-tcl --with-tcl=%{_libdir} \
		--enable-cxx --enable-test \
		# --enable-diagnostic \
		# --enable-debug --enable-debug_rop --enable-debug_wop \
		# --enable-posixmutexes

	soversion=`echo ${version} | cut -f1,2 -d.`
	make libdb=%{_libdb_a} libcxx=%{_libcxx_a}
	popd
done


# remove dangling tags symlink from examples.
rm -f examples_cxx/tags
rm -f examples_c/tags

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}

pushd db2
# Install the shared library.
install -m755 libdb2.so.* $RPM_BUILD_ROOT/%{_libdir}/
# Install the utilities.
for utility in db_archive db_checkpoint db_deadlock db_dump db_load \
db_printlog db_recover db_stat ; do
	install -m755 $utility $RPM_BUILD_ROOT/%{_bindir}/
done
# Rename the utilities.
major=2
for bin in $RPM_BUILD_ROOT/%{_bindir}/*db_* ; do
	t=`echo ${bin} | sed "s,db_,db${major}_,g"`
	mv ${bin} ${t}
done
popd

for version in %{db3_versions} %{db4_versions} ; do
	pushd db-${version}/dist
	%makeinstall libdb=%{_libdb_a} libcxx=%{_libcxx_a}
	# Rename the utilities.
	major=`echo ${version} | cut -c1,3`
	for bin in $RPM_BUILD_ROOT/%{_bindir}/*db_* ; do
		t=`echo ${bin} | sed "s,db_,db${major}_,g"`
		mv ${bin} ${t}
	done
	popd
done

# Make sure all shared libraries have the execute bit set.
chmod 755 $RPM_BUILD_ROOT/%{_libdir}/libdb*.so*

# On Linux systems, move the shared libraries to lib directory.
%ifos linux
if [ "%{_libdir}" != "%{_lib}" ]; then
        mkdir -p $RPM_BUILD_ROOT/%{_lib}
        mv $RPM_BUILD_ROOT/%{_libdir}/libdb2.so.* $RPM_BUILD_ROOT/%{_lib}/
        mv $RPM_BUILD_ROOT/%{_libdir}/libdb-*?.?.so* $RPM_BUILD_ROOT/%{_lib}/
fi
%endif

# Remove unpackaged files.
rm -f $RPM_BUILD_ROOT/%{_includedir}/*
rm -f $RPM_BUILD_ROOT/%{_libdir}/*.la
rm -fr $RPM_BUILD_ROOT/%{_libdir}/*.la
rm -fr $RPM_BUILD_ROOT/%{_prefix}/docs/

%clean
rm -rf ${RPM_BUILD_ROOT}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc docs/*
%ifos linux
/%{_lib}/libdb2.so*
/%{_lib}/libdb-?.?.so
%else
%{_libdir}/libdb2.so*
%{_libdir}/libdb-?.?.so
%endif
%{_libdir}/libdb_cxx-?.?.so
%{_libdir}/libdb_tcl-?.?.so
%{_bindir}/berkeley_db*_svc
%{_bindir}/db*_archive
%{_bindir}/db*_checkpoint
%{_bindir}/db*_deadlock
%{_bindir}/db*_dump
%{_bindir}/db*_load
%{_bindir}/db*_printlog
%{_bindir}/db*_recover
%{_bindir}/db*_stat
%{_bindir}/db*_upgrade
%{_bindir}/db*_verify

%changelog
* Tue Aug 19 2003 Nalin Dahyabhai <nalin@redhat.com> 4.0.14-5
- add missing tcl-devel buildrequires (#101814)

* Thu Jun 26 2003 Jeff Johnson <jbj@redhat.com> 4.0.14-3
- compile on all platforms, use gcc296 only on i386/alpha/ia64
- avoid ppc64 toolchain for the nonce.

* Wed May  7 2003 Bill Nottingham <notting@redhat.com> 4.0.14-2
- build db-4.x with system compiler, not compat-gcc

* Mon May  5 2003 Jeff Johnson <jbj@redhat.com> 4.0.14-1
- add db4.0.14 to the mess.

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Tue Nov 19 2002 Nalin Dahyabhai <nalin@redhat.com> 3.3.11-3
- add sed as a built-time dependency

* Wed Sep 25 2002 Nalin Dahyabhai <nalin@redhat.com>
- fold x86-64 changes into mainline

* Mon Sep 09 2002 Tim Powers <timp@redhat.com>
- x86-64 specific build

* Sun May 26 2002 Tim Powers <timp@redhat.com> 3.3.11-2
- automated rebuild

* Thu May 16 2002 Nalin Dahyabhai <nalin@redhat.com> 3.3.11-1
- pull in db 3.3, obsolete db3 and db32 in addition to db31
- build with compat-gcc/compat-gcc-c++ to get C++ shared libraries suitable
  for use in applications built with db3-devel on RHL 7.x
- pull in db2, obsolete db2/db2-devel/db3-devel, rename to compat-db
- obsolete db3x

* Thu Mar 28 2002 Nalin Dahyabhai <nalin@redhat.com> 3.2.9-4
- rebuild

* Thu Mar 28 2002 Nalin Dahyabhai <nalin@redhat.com> 3.2.9-3
- don't list the tcl include path before other flags when building libdb_tcl
  3.1.x (tcl is in /usr, so this pulls in /usr/include/db.h, which is wrong)

* Mon Mar 25 2002 Nalin Dahyabhai <nalin@redhat.com> 3.2.9-2
- rebuild

* Mon Mar 25 2002 Nalin Dahyabhai <nalin@redhat.com> 3.2.9-1
- rename to db3x and merge in db 3.1 and db 3.2 compatibility stuffs

* Mon Apr 16 2001 Nalin Dahyabhai <nalin@redhat.com>
- rename to db31, drop the -devel subpackage, merge the -utils package
- remove berkeley_db_svc, libdb_tcl.so (conflicts with current -utils)

* Thu Apr 05 2001 Nalin Dahyabhai <nalin@redhat.com>
- fix URLs in docs for the -utils and -devel subpackages to point to the
  images in the main package's documentation directory (#33328)
- change Copyright: GPL to License: BSDish

* Fri Mar 23 2001 Bill Nottingham <notting@redhat.com>
- turn off --enable-debug

* Tue Dec 12 2000 Jeff Johnson <jbj@redhat.com>
- rebuild to remove 777 directories.

* Sat Nov 11 2000 Jeff Johnson <jbj@redhat.com>
- don't build with --enable-diagnostic.
- add build prereq on tcl.
- default value for %%_lib macro if not found.

* Tue Oct 17 2000 Jeff Johnson <jbj@redhat.com>
- add /usr/lib/libdb-3.1.so symlink to %%files.
- remove dangling tags symlink from examples.

* Mon Oct  9 2000 Jeff Johnson <jbj@redhat.com>
- rather than hack *.la (see below), create /usr/lib/libdb-3.1.so symlink.
- turn off --enable-diagnostic for performance.

* Fri Sep 29 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.1.17.
- disable posix mutexes Yet Again.

* Tue Sep 26 2000 Jeff Johnson <jbj@redhat.com>
- add c++ and posix mutex support.

* Thu Sep 14 2000 Jakub Jelinek <jakub@redhat.com>
- put nss_db into a separate package

* Wed Aug 30 2000 Matt Wilson <msw@redhat.com>
- rebuild to cope with glibc locale binary incompatibility, again

* Wed Aug 23 2000 Jeff Johnson <jbj@redhat.com>
- remove redundant strip of libnss_db* that is nuking symbols.
- change location in /usr/lib/libdb-3.1.la to point to /lib (#16776).

* Thu Aug 17 2000 Jeff Johnson <jbj@redhat.com>
- summaries from specspo.
- all of libdb_tcl* (including symlinks) in db3-utils, should be db3->tcl?

* Wed Aug 16 2000 Jakub Jelinek <jakub@redhat.com>
- temporarily build nss_db in this package, should be moved
  into separate nss_db package soon

* Wed Jul 19 2000 Jakub Jelinek <jakub@redhat.com>
- rebuild to cope with glibc locale binary incompatibility

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Sun Jun 11 2000 Jeff Johnson <jbj@redhat.com>
- upgrade to 3.1.14.
- create db3-utils sub-package to hide tcl dependency, enable tcl Yet Again.
- FHS packaging.

* Mon Jun  5 2000 Jeff Johnson <jbj@redhat.com>
- disable tcl Yet Again, base packages cannot depend on libtcl.so.

* Sat Jun  3 2000 Jeff Johnson <jbj@redhat.com>
- enable tcl, rebuild against tcltk 8.3.1 (w/o pthreads).

* Tue May 30 2000 Matt Wilson <msw@redhat.com>
- include /lib/libdb.so in the devel package

* Wed May 10 2000 Jeff Johnson <jbj@redhat.com>
- put in "System Environment/Libraries" per msw instructions.

* Tue May  9 2000 Jeff Johnson <jbj@redhat.com>
- install shared library in /lib, not /usr/lib.
- move API docs to db3-devel.

* Mon May  8 2000 Jeff Johnson <jbj@redhat.com>
- don't rename db_* to db3_*.

* Tue May  2 2000 Jeff Johnson <jbj@redhat.com>
- disable --enable-test --enable-debug_rop --enable-debug_wop.
- disable --enable-posixmutexes --enable-tcl as well, to avoid glibc-2.1.3
  problems.

* Mon Apr 24 2000 Jeff Johnson <jbj@redhat.com>
- add 3.0.55.1 alignment patch.
- add --enable-posixmutexes (linux threads has not pthread_*attr_setpshared).
- add --enable-tcl (needed -lpthreads).

* Sat Apr  1 2000 Jeff Johnson <jbj@redhat.com>
- add --enable-debug_{r,w}op for now.
- add variable to set shm perms.

* Sat Mar 25 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.0.55

* Tue Dec 29 1998 Jeff Johnson <jbj@redhat.com>
- Add --enable-cxx to configure.

* Thu Jun 18 1998 Jeff Johnson <jbj@redhat.com>
- Create.
